/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomDOMImplementation_H__
#define __GdomDOMImplementation_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomCSSStyleSheet.h"
#include "gdom/GdomDOMObject.h"
#include "gdom/GdomDocument.h"
#include "gdom/GdomDocumentType.h"
#include "gdom/GdomHTMLDocument.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomDOMImplementation GdomDOMImplementation;
typedef struct _GdomDOMImplementationClass GdomDOMImplementationClass;


#define GDOM_TYPE_DOM_IMPLEMENTATION            (gdom_dom_implementation_get_type())
#define GDOM_DOM_IMPLEMENTATION(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_DOM_IMPLEMENTATION, GdomDOMImplementation))
#define GDOM_DOM_IMPLEMENTATION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_DOM_IMPLEMENTATION, GdomDOMImplementation)Class)
#define GDOM_IS_DOM_IMPLEMENTATION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_DOM_IMPLEMENTATION))
#define GDOM_IS_DOM_IMPLEMENTATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_DOM_IMPLEMENTATION))
#define GDOM_DOM_IMPLEMENTATION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_DOM_IMPLEMENTATION, GdomDOMImplementationClass))

typedef struct _GdomDOMImplementationPrivate GdomDOMImplementationPrivate;

struct _GdomDOMImplementation {
    GdomDOMObject parent_instance;
    GdomDOMImplementationPrivate *priv;
};

struct _GdomDOMImplementationClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_dom_implementation_get_type (void);

WEBKIT_API gboolean
gdom_dom_implementation_has_feature (GdomDOMImplementation *thiz, gchar * feature, gchar * version);

WEBKIT_API GdomDocumentType *
gdom_dom_implementation_create_document_type (GdomDOMImplementation *thiz, gchar * qualified_name, gchar * public_id, gchar * system_id);

WEBKIT_API GdomDocument *
gdom_dom_implementation_create_document (GdomDOMImplementation *thiz, gchar * namespace_uri, gchar * qualified_name, GdomDocumentType * doctype);

WEBKIT_API GdomCSSStyleSheet *
gdom_dom_implementation_create_css_style_sheet (GdomDOMImplementation *thiz, gchar * title, gchar * media);

WEBKIT_API GdomHTMLDocument *
gdom_dom_implementation_create_html_document (GdomDOMImplementation *thiz, gchar * title);

G_END_DECLS

#endif /* __GdomDOMImplementation_H__ */
